import 'lines.dart';

extension MacroExtension on String {
  bool isMacro(String command) {
    var line = trim().toLowerCase();
    return line.startsWith('<!-- #$command ') && line.endsWith('-->');
  }

  bool isAnyMacro() {
    var line = trim().toLowerCase();
    return line.startsWith('<!-- #') && line.endsWith('-->');
  }

  bool isMacroEnd(String command) {
    return trim() == '<!-- // end of #$command -->';
  }

  bool isAnyMacroEnd() {
    var line = trim().toLowerCase();
    return line.startsWith('<!-- // end of #') && line.endsWith('-->');
  }

  String get macroContent {
    return RegExp(r'<!-- (#.*?) -->').firstMatch(this)?.group(1) ?? '';
  }
}

List<String> removeGeneratedBlocks(List<String> lines, String command) {
  var result = Lines();

  for (var line in lines) {
    result.add(line);

    if (line.isMacroEnd(command)) {
      result.discard();
    } else if (line.isMacro(command)) {
      result.accept();
    }
  }
  return result.data();
}
